SET TERM !! ;
CREATE PROCEDURE GetPredictForUT( ut TIMESTAMP)
  RETURNS( DMP FLOAT, DPLA FLOAT, FCE FLOAT, FPE FLOAT, FMP FLOAT, PFMP FLOAT,
           MLT FLOAT, MLAT FLOAT, ILAT FLOAT, L FLOAT, RE FLOAT, XSM FLOAT,
           YSM FLOAT, ZSM FLOAT, XMP FLOAT, YMP FLOAT, ZMP FLOAT,
           LON FLOAT, LAT FLOAT) 
AS
DECLARE VARIABLE t1 TIMESTAMP;
DECLARE VARIABLE t2 TIMESTAMP;
DECLARE VARIABLE DMP1   FLOAT;
DECLARE VARIABLE DPLA1  FLOAT;
DECLARE VARIABLE FCE1   FLOAT;
DECLARE VARIABLE FPE1   FLOAT;
DECLARE VARIABLE FMP1   FLOAT;
DECLARE VARIABLE PFMP1  FLOAT;
DECLARE VARIABLE MLT1   FLOAT;
DECLARE VARIABLE MLAT1  FLOAT;
DECLARE VARIABLE ILAT1  FLOAT;
DECLARE VARIABLE L1     DOUBLE PRECISION;
DECLARE VARIABLE RE1    FLOAT;
DECLARE VARIABLE XSM1   FLOAT;
DECLARE VARIABLE YSM1   FLOAT;
DECLARE VARIABLE ZSM1   FLOAT;
DECLARE VARIABLE XMP1   FLOAT;
DECLARE VARIABLE YMP1   FLOAT;
DECLARE VARIABLE ZMP1   FLOAT;
DECLARE VARIABLE LON1   FLOAT;
DECLARE VARIABLE LAT1   FLOAT;
DECLARE VARIABLE DMP2   FLOAT;
DECLARE VARIABLE DPLA2  FLOAT;
DECLARE VARIABLE FCE2   FLOAT;
DECLARE VARIABLE FPE2   FLOAT;
DECLARE VARIABLE FMP2   FLOAT;
DECLARE VARIABLE PFMP2  FLOAT;
DECLARE VARIABLE MLT2   FLOAT;
DECLARE VARIABLE MLAT2  FLOAT;
DECLARE VARIABLE ILAT2  FLOAT;
DECLARE VARIABLE L2     DOUBLE PRECISION;
DECLARE VARIABLE RE2    FLOAT;
DECLARE VARIABLE XSM2   FLOAT;
DECLARE VARIABLE YSM2   FLOAT;
DECLARE VARIABLE ZSM2   FLOAT;
DECLARE VARIABLE XMP2   FLOAT;
DECLARE VARIABLE YMP2   FLOAT;
DECLARE VARIABLE ZMP2   FLOAT;
DECLARE VARIABLE LON2   FLOAT;
DECLARE VARIABLE LAT2   FLOAT;
DECLARE VARIABLE coeff  FLOAT;
BEGIN
  SELECT MAX(Time_UT) FROM Prediction WHERE Time_UT <= :ut INTO :t1;
  SELECT MIN(Time_UT) FROM Prediction WHERE Time_UT >= :ut INTO :t2;
  IF( t1 <> '1900.01.01' ) THEN
    IF( ut - t1 >= 0.2 ) THEN t1 = '1900.01.01';
  IF( t2 <> '1900.01.01' ) THEN
    IF( t2 - ut >= 0.2 ) THEN t2 = '1900.01.01';
  IF( t1 <> '1900.01.01' ) THEN
  BEGIN
    SELECT DMP, DPLA, FCE, FPE, FMP, PFMP, MLT, MLAT, ILAT, L, RE,
           XSM, YSM, ZSM, XMP, YMP, ZMP, LON, LAT
      FROM Prediction
      WHERE Time_UT = :t1
      INTO :DMP1, :DPLA1, :FCE1, :FPE1, :FMP1, :PFMP1, :MLT1, :MLAT1, :ILAT1,
           :L1, :RE1, :XSM1, :YSM1, :ZSM1, :XMP1, :YMP1, :ZMP1, :LON1, :LAT1;
    IF( t2 <> t1 AND t2 <> '1900.01.01' ) THEN
    BEGIN
      SELECT DMP, DPLA, FCE, FPE, FMP, PFMP, MLT, MLAT, ILAT, L, RE,
             XSM, YSM, ZSM, XMP, YMP, ZMP, LON, LAT
        FROM Prediction
        WHERE Time_UT = :t2
        INTO :DMP2, :DPLA2, :FCE2, :FPE2, :FMP2, :PFMP2, :MLT2, :MLAT2, :ILAT2,
             :L2, :RE2, :XSM2, :YSM2, :ZSM2, :XMP2, :YMP2, :ZMP2, :LON2, :LAT2;
      coeff = ( ut - t1 ) / ( t2 - t1 );
      DMP = DMP1 + ( DMP2 - DMP1 ) * coeff;
      DPLA = DPLA1 + ( DPLA2 - DPLA1 ) * coeff;
      FCE  = FCE1 + ( FCE2 - FCE1 ) * coeff;
      FPE  = FPE1 + ( FPE2 - FPE1 ) * coeff;
      FMP  = FMP1 + ( FMP2 - FMP1 ) * coeff;
      PFMP = PFMP1 + ( PFMP2 - PFMP1 ) * coeff;
      MLT  = MLT1 + ( MLT2 - MLT1 ) * coeff;
      MLAT = MLAT1 + ( MLAT2 - MLAT1 ) * coeff;
      ILAT = ILAT1 + ( ILAT2 - ILAT1 ) * coeff;
      L    = L1 + ( L2 - L1 ) * coeff;
      RE   = RE1 + ( RE2 - RE1 ) * coeff;
      XSM  = XSM1 + ( XSM2 - XSM1 ) * coeff;
      YSM  = YSM1 + ( YSM2 - YSM1 ) * coeff;
      ZSM  = ZSM1 + ( ZSM2 - ZSM1 ) * coeff;
      XMP  = XMP1 + ( XMP2 - XMP1 ) * coeff;
      YMP  = YMP1 + ( YMP2 - YMP1 ) * coeff;
      ZMP  = ZMP1 + ( ZMP2 - ZMP1 ) * coeff;
      LON  = LON1 + ( LON2 - LON1 ) * coeff;
      LAT  = LAT1 + ( LAT2 - LAT1 ) * coeff;
      SUSPEND;
    END
    ELSE
    BEGIN
      DMP  = DMP1;
      DPLA = DPLA1;
      FCE  = FCE1;
      FPE  = FPE1;
      FMP  = FMP1;
      PFMP = PFMP1;
      MLT  = MLT1;
      MLAT = MLAT1;
      ILAT = ILAT1;
      L    = L1;
      RE   = RE1;
      XSM  = XSM1;
      YSM  = YSM1;
      ZSM  = ZSM1;
      XMP  = XMP1;
      YMP  = YMP1;
      ZMP  = ZMP1;
      LON  = LON1;
      LAT  = LAT1;
      SUSPEND;
    END
  END
  ELSE
  BEGIN
    IF( t2 <> '1900.01.01' ) then
    BEGIN
      SELECT DMP, DPLA, FCE, FPE, FMP, PFMP, MLT, MLAT, ILAT, L, RE,
             XSM, YSM, ZSM, XMP, YMP, ZMP, LON, LAT
        FROM Prediction
        WHERE Time_UT = :t2
        INTO :DMP, :DPLA, :FCE, :FPE, :FMP, :PFMP, :MLT, :MLAT, :ILAT,
             :L, :RE, :XSM, :YSM, :ZSM, :XMP, :YMP, :ZMP, :LON, :LAT;
      SUSPEND;
    END
  END
END!!
SET TERM ; !!
